#include "chatmessagedelegate.h"

ChatMessageDelegate::ChatMessageDelegate()
{
}


void ChatMessageDelegate::paint(QPainter *painter, const QStyleOptionViewItem &options,
                            const QModelIndex &index) const
{
    //If you call this the "selected" background color will be used
    //QStyledItemDelegate::paint(painter,options,index);

    painter->save();

    QString message = qvariant_cast<QString>(index.data(ChatMessageDelegate::textRole));

    QLabel *label = new QLabel();
    label->setTextFormat(Qt::RichText);
    label->setOpenExternalLinks(true);
    label->setWordWrap(true);
    label->setAlignment(Qt::AlignTop|Qt::AlignLeft);
    //label->setSizePolicy(QSizePolicy::Minimum,QSizePolicy::Maximum);
    label->setFixedSize(options.rect.width(), options.rect.height());
    label->setText(message);
    painter->translate(options.rect.left(), options.rect.top());
    label->render(painter);

    /*QTextDocument *label = new QTextDocument();
    label->setHtml(message);

    painter->translate(options.rect.left(), options.rect.top());
    QRect clip(0, 0, options.rect.width(), options.rect.height());

    label->drawContents(painter, clip);
    */

    painter->restore();
}

QSize ChatMessageDelegate::sizeHint(const QStyleOptionViewItem&,
                            const QModelIndex&) const
{
#ifdef Q_WS_MAEMO_5
    return QSize(460, 96);
#else
    return QSize(460, 48);
#endif
}
