#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    connect(ui->listView->verticalScrollBar(), SIGNAL(valueChanged(int)),
            this,SLOT(readMoreLogLines(int)));

    m_DataModel = new QStandardItemModel(this);
    m_Delegate = new ChatMessageDelegate();
    ui->listView->setViewMode(QListView::ListMode);
    ui->listView->setItemDelegate(m_Delegate);
    ui->listView->setModel(m_DataModel);

    line = 0;
    readMoreLogLines(0);
    ui->listView->scrollToBottom();
}

void MainWindow::readMoreLogLines(int value)
{
    if (value == 0){
        QList<QString> list;
        for (int j = 0; j < 10; j++)
        {
            list.append(QString::number(line++));
        }

        loadLogMessages(list);
    }
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::loadLogMessages(QList<QString> list)
{
    foreach (QString s, list){
        QStandardItem* item = new QStandardItem();
        item->setData("???", ChatMessageDelegate::idRole);
        item->setData(s, ChatMessageDelegate::textRole);

        m_DataModel->insertRow(0, item);
    }
}
